SystemOrganization addCategory: #Jihachol!

TestCase subclass: #JhcLineJooyungHanTest
	instanceVariableNames: 'line scrum tdd refactoring pp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineJooyungHanTest commentStamp: 'hjo 10/13/2009 10:48' prior: 0!
hjo: I think this class can be merged to other testing class. Too simple to stay alone.!

!JhcLineJooyungHanTest methodsFor: 'running' stamp: 'jhan 10/12/2009 00:31'!
setUp

	| input |
	input := 'jh01	Refactoring	2
jh02	TDD	2
jh03	PP	2
jh04	Scrum	2'.
	line := JhcLine loadData: input for: 'Jooyung Han'.
	
	scrum := line stationAtName: 'Scrum'.
	tdd := line stationAtName: 'TDD'.
	refactoring := line stationAtName: 'Refactoring'.
	pp := line stationAtName: 'PP'.
	! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:48'!
testCircularLine
	self assert: (refactoring neighbors includes: tdd).
	self assert: (tdd neighbors includes: pp).
	self assert: (pp neighbors includes: scrum).
	self assert: (scrum neighbors includes: refactoring).! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:26'!
testStationCount
	self assert:4 equals: line stations size! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:04'!
testTimeSpan
	|cost|
	cost := JhcStation defaultCost.
	self assert: 0 equals: (refactoring timespanMinutesTo: refactoring).
	self assert: cost equals: (refactoring timespanMinutesTo: tdd).
	self assert: cost*2 equals: (refactoring timespanMinutesTo: pp).! !

TestCase subclass: #JhcLineRealDataTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

JhcLineRealDataTest subclass: #JhcBundangLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcBundangLineTest methodsFor: 'running' stamp: 'hjo 9/28/2009 13:12'!
setUp

	super setUp.
	line := JhcLine bundang.
	
	

	! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:35'!
testDogok

	| s |
	s := line stations at: 3.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Dogok'.
	self assert: s id equals: 'K217'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:40'!
testGaepoDong

	| s |
	s := line stations at: 5.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Gaepo-dong'.
	self assert: s id equals: 'K219'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:37'!
testGuryong

	| s |
	s := line stations at: 4.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Guryong'.
	self assert: s id equals: 'K218'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:35'!
testHanti

	| s |
	s := line stations at: 2.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Hanti'.
	self assert: s id equals: 'K216'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:47'!
testOri

	| s |
	s := line stations at: 18.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Ori'.
	self assert: s id equals: 'K232'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:33'!
testSeolleung

	| s |
	s := line stations at: 1.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Seolleung'.
	self assert: s id equals: 'K215'! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:38'!
testTimeSpanFromBojeongToGaepoDong

	self assert: (self timeFrom: 'Gaepo-dong' to: 'Bojeong') equals: 40! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:39'!
testTimeSpanFromDogokToSeolleung

	self assert: (self timeFrom: 'Seolleung' to: 'Dogok') equals: 4! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:40'!
testTimeSpanFromSuseoToKyungwonUniv

	self assert: (self timeFrom: 'Suseo' to: 'Kyungwon Univ.') equals: 7! !

JhcLineRealDataTest subclass: #JhcLine1Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine1Test methodsFor: 'running' stamp: 'hjo 10/13/2009 13:30'!
setUp

	super setUp.
	line := JhcLine line1! !

!JhcLine1Test methodsFor: 'station' stamp: 'hjo 10/19/2009 17:08'!
testCheongnyangni

	| station |
	station := line stationAtName: 'Cheongnyangni'.
	self assert: station line equals: '1'.
	self assert: station id equals: '124'.
	self assert: station name equals: 'Cheongnyangni'.
	self assert: station secondName equals: nil! !

!JhcLine1Test methodsFor: 'station' stamp: 'hjo 10/19/2009 17:09'!
testDongdaemun

	| station |
	station := line stationAtName: 'Dongdaemun'.
	self assert: station line equals: '1'.
	self assert: station id equals: '128'.
	self assert: station name equals: 'Dongdaemun'.
	self assert: station secondName equals: nil! !

!JhcLine1Test methodsFor: 'routing' stamp: 'hjo 10/13/2009 13:40'!
testFromDongdaemunToJegidong

	self assert: (self timeFrom: 'Dongdaemun' to: 'Jegi-dong') equals: 5! !

!JhcLine1Test methodsFor: 'routing' stamp: 'hjo 10/13/2009 13:36'!
testFromSeoulStationToJonggak

	self assert: (self timeFrom: 'Seoul Station' to: 'Jonggak') equals: 5! !

!JhcLine1Test methodsFor: 'routing' stamp: 'hjo 10/13/2009 13:39'!
testFromSeoulStationToSeoulStation

	self assert: (self timeFrom: 'Seoul Station' to: 'Seoul Station') equals: 0! !

!JhcLine1Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 13:50'!
testLineColor

	self assert: line lineColor equals: (Color r: 13/255 g: 54/255 b: 146/255)! !

!JhcLine1Test methodsFor: 'station' stamp: 'hjo 10/19/2009 17:09'!
testSeoulStation

	| station |
	station := line stationAtName: 'Seoul Station'.
	self assert: station line equals: '1'.
	self assert: station id equals: '133'.
	self assert: station name equals: 'Seoul Station'.
	self assert: station secondName equals: nil! !

JhcLineRealDataTest subclass: #JhcLine2RingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2RingTest methodsFor: 'running' stamp: 'hjo 10/10/2009 08:44'!
setUp

	super setUp.
	line := JhcLine line2Ring! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:10'!
testAhyeon

	| station |
	station := line stations at: 42.
	self assert: station line equals: '2'.
	self assert: station id equals: '242'.
	self assert: station name equals: 'Ahyeon'.
	self assert: station secondName equals: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:10'!
testChungjeongno

	| station |
	station := line stations at: 43.
	self assert: station line equals: '2'.
	self assert: station id equals: '243'.
	self assert: station name equals: 'Chungjeongno'.
	self assert: station secondName equals: 'Kyonggi Univ.'! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:50'!
testCityHall

	| station |
	station := line stations at: 1.
	self assert: station name equals: 'City Hall'.
	self assert: station id equals: '201'.
	self assert: station line equals: '2'.
	self assert: station secondName equals: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:50'!
testEuljiroSamGa

	| station |
	station := line stations at: 3.
	self assert: station name equals: 'Euljiro 3(sam)-ga'.
	self assert: station id equals: '203'.
	self assert: station line equals: '2'.
	self assert: station secondName equals: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:50'!
testEuljiroilga

	| station |
	station := line stations at: 2.
	self assert: station name equals: 'Euljiro 1(il)-ga'.
	self assert: station id equals: '202'.
	self assert: station line equals: '2'.
	self assert: station secondName equals: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:51'!
testEwhaWomansUniv

	| station |
	station := line stations at: 41.
	self assert: station line equals: '2'.
	self assert: station id equals: '241'.
	self assert: station name equals: 'Ewha Womans Univ.'.
	self assert: station secondName equals: nil! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:41'!
testFromCityHallToAhyeon

	self assert: (self timeFrom: 'City Hall' to: 'Ahyeon') equals: 4! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:44'!
testFromCityHallToDongdaemun

	self assert: (self timeFrom: 'City Hall' to: 'Dongdaemun Stadium') equals: 7! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:44'!
testFromCityHallToSeongnae

	self assert: (self timeFrom: 'City Hall' to: 'Seongnae') equals: 28! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:45'!
testFromSeongnaeToSindaebang

	self assert: (self timeFrom: 'Sindaebang' to: 'Seongnae') equals: 34! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:45'!
testFromSindaebangToCityHall

	self assert: (self timeFrom: 'Sindaebang' to: 'City Hall') equals: 29! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:51'!
testSeongsu

	| station |
	station := line stations at: 11.
	self assert: station line equals: '2'.
	self assert: station id equals: '211'.
	self assert: station name equals: 'Seongsu'.
	self assert: station secondName equals: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/19/2009 17:52'!
testSindorim

	| station |
	station := line stations at: 34.
	self assert: station line equals: '2'.
	self assert: station id equals: '234'.
	self assert: station name equals: 'Sindorim'.
	self assert: station secondName equals: nil! !

JhcLineRealDataTest subclass: #JhcLine2SeongsuBranchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2SeongsuBranchTest methodsFor: 'running' stamp: 'hjo 10/8/2009 19:53'!
setUp

	super setUp.
	line := JhcLine line2SeongsuBranch! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:47'!
testFromSeongsuToSinseolDong

	self assert: (self timeFrom: 'Seongsu' to: 'Sinseol-dong') equals: 9! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:48'!
testFromSinseolDongToYongdap

	self assert: (self timeFrom: 'Sinseol-dong' to: 'Yongdap') equals: 6! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:49'!
testFromYongdapToSindap

	self assert: (self timeFrom: 'Yongdap' to: 'Sindap') equals: 2! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/19/2009 17:53'!
testSeongsu

	| station |
	station := line stations at: 1.
	self assert: station line equals: '2-seongsu-branch'.
	self assert: station id equals: '211'.
	self assert: station name equals: 'Seongsu'.
	self assert: station secondName equals: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/19/2009 17:53'!
testSindap

	| station |
	station := line stations at: 3.
	self assert: station line equals:  '2-seongsu-branch'.
	self assert: station id equals: '211-2'.
	self assert: station name equals: 'Sindap'.
	self assert: station secondName equals: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/19/2009 17:53'!
testSinseoldong

	| station |
	station := line stations at: 5.
	self assert: station line equals:  '2-seongsu-branch'.
	self assert: station id equals: '211-4'.
	self assert: station name equals: 'Sinseol-dong'.
	self assert: station secondName equals: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/19/2009 17:53'!
testYongdap

	| station |
	station := line stations at: 2.
	self assert: station line equals:  '2-seongsu-branch'.
	self assert: station id equals: '211-1'.
	self assert: station name equals: 'Yongdap'.
	self assert: station secondName equals: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/19/2009 17:54'!
testYongdu

	| station |
	station := line stations at: 4.
	self assert: station line equals:  '2-seongsu-branch'.
	self assert: station id equals: '211-3'.
	self assert: station name equals: 'Yongdu'.
	self assert: station secondName equals: 'Dongdaemun-gu Office'.! !

JhcLineRealDataTest subclass: #JhcLine2SinjeongBranchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2SinjeongBranchTest methodsFor: 'running' stamp: 'hjo 10/9/2009 22:18'!
setUp

	super setUp.
	line := JhcLine line2SinjeongBranch! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'jhan 10/13/2009 10:02'!
testDorimcheon

	| station |
	station := line stations at: 2.
	self assert: station line equals: '2-sinjeong-branch'.
	self assert: station id equals: '234-1'.
	self assert: station name equals: 'Dorimcheon'! !

!JhcLine2SinjeongBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:53'!
testFromDorimcheonToSinjeongnegeori

	self assert: (self timeFrom: 'Dorimcheon' to: 'Sinjeongnegeori') equals: 7! !

!JhcLine2SinjeongBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:52'!
testFromSindorimToKkachisan

	self assert: (self timeFrom: 'Sindorim' to: 'Kkachisan') equals:  12! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'jhan 10/13/2009 10:01'!
testKkachisan

	| station |
	station := line stations at: 5.
	self assert: station line equals: '2-sinjeong-branch'.
	self assert: station id equals: '234-4'.
	self assert: station name equals: 'Kkachisan'! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'jhan 10/13/2009 10:01'!
testSindorim

	| station |
	station := line stations at: 1.
	self assert: station line equals: '2-sinjeong-branch'.
	self assert: station id equals: '234'.
	self assert: station name equals: 'Sindorim'! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'jhan 10/13/2009 10:01'!
testSinjeongnegeori

	| station |
	station := line stations at: 4.
	self assert: station line equals: '2-sinjeong-branch'.
	self assert: station id equals: '234-3'.
	self assert: station name equals: 'Sinjeongnegeori'! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'jhan 10/13/2009 10:01'!
testYangcheonGuOffice

	| station |
	station := line stations at: 3.
	self assert: station line equals: '2-sinjeong-branch'.
	self assert: station id equals: '234-2'.
	self assert: station name equals: 'Yangcheon-gu Office'! !

JhcLineRealDataTest subclass: #JhcLine2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2Test methodsFor: 'running' stamp: 'jhan 10/13/2009 09:54'!
setUp

	super setUp.
	line := JhcLine line2! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 15:09'!
testFromMullaeToDorimcheon

	self assert: (self timeFrom: 'Mullae' to: 'Dorimcheon') equals: 18! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 09:55'!
testFromSeongsuToSomewhere

	self assert: (self timeFrom: 'Seongsu' to: 'Ttukseom') equals: 1.
	self assert: (self timeFrom: 'Seongsu' to: 'Sinseol-dong') equals: 9.
	self assert: (self timeFrom: 'Ttukseom' to: 'Seongsu') equals: 1.
	self assert: (self timeFrom: 'Sinseol-dong' to: 'Seongsu') equals: 9! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 16:28'!
testFromWangsimniToSindap
	"Wangsimni 2 Hanyang Univ. 3 Ttukseom 1 Seongsu 11 Seongsu 3 Yongdap 2 Sindap => 22 minutes"
	self assert: (self timeFrom: 'Wangsimni' to: 'Sindap') equals: 22! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:27'!
testLineColor

	"RGB 51,162,61"
	self assert: line lineColor equals: (Color r: 51/255 g: 162/255 b: 61/255)! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:24'!
testSeongsuHasTwoLines
	| seongsu |
	seongsu := line stationAtName: 'Seongsu'.
	self assert: seongsu lines equalsArray: #('2' '2-seongsu-branch')! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 09:02'!
testStationsOfEachPartExist

	self shouldnt: [line stations detect: [:each| each name = 'Wangsimni' ]] raise: Error.
	self shouldnt: [line stations detect: [:each| each name = 'Yongdap' ]] raise: Error.
	self shouldnt: [line stations detect: [:each| each name = 'Dorimcheon' ]] raise: Error	! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:28'!
testTtukseomHasOneLine
	| station |
	station := line stationAtName: 'Ttukseom'.
	self assert: station lines equalsArray: #('2')! !

JhcLineRealDataTest subclass: #JhcLine3Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:12'!
setUp
	line := JhcLine line3! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:25'!
testFromDaehwaToJeongbalsan
	self assert: (self timeFrom: 'Daehwa' to: 'Jeongbalsan') equals: 5.! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:25'!
testFromDaehwaToMadu

	self assert: (self timeFrom: 'Daehwa' to: 'Madu') equals: 7.! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:20'!
testFromDaehwaToSuseo
	self assert: (self timeFrom: 'Daehwa' to: 'Suseo') equals: 90! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:28'!
testLineColor

	"RGB 254,91,16"
	self assert: line lineColor equals: (Color r: 254/255 g: 91/255 b: 16/255)! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:11'!
testLineId
	self assert: ('3' = line line)! !

JhcLineRealDataTest subclass: #JhcLine4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine4Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:34'!
setUp

	super setUp.
	line := JhcLine line4! !

!JhcLine4Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:35'!
testLineColor

	self assert: line lineColor equals: (Color r:50/255 g:161/255 b: 200/255) ! !

JhcLineRealDataTest subclass: #JhcLine5Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine5Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:37'!
setUp

	super setUp.
	line := JhcLine line5! !

!JhcLine5Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:37'!
testLineColor

	self assert: line lineColor equals: (Color r:139/255 g:80/255 b:164/255)! !

JhcLineRealDataTest subclass: #JhcLine6Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine6Test methodsFor: 'running' stamp: 'hjo 9/28/2009 18:59'!
setUp

	super setUp.
	line := JhcLine line6! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 10:12'!
testBonghwasan

	| station |
	station := line stations at: 38.
	self assert: station line equals: '6'.
	self assert: station id equals: '647'.
	self assert: station name equals: 'Bonghwasan'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/28/2009 19:15'!
testEungam

	| station |
	station := line stations at: 1.
	self assert: station line equals: '6'.
	self assert: station id equals: '610'.
	self assert: station name equals: 'Eungam'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 11:26'!
testGusan

	| station |
	station := line stations at: 6.
	self assert: station line equals: '6'.
	self assert: station id equals: '615'.
	self assert: station name equals: 'Gusan'! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:40'!
testLineColor

	"RGB 197,92,29"
	self assert: line lineColor equals: (Color r:197/255 g:92/255 b:29/255 )! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/8/2009 16:19'!
testMangwon

	| station |
	station := line stations at: 12.
	self assert: station line equals: '6'.
	self assert: station id equals: '621'.
	self assert: station name equals: 'Mangwon'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/28/2009 19:16'!
testSaejeol

	| station |
	station := line stations at: 7.
	self assert: station line equals: '6'.
	self assert: station id equals: '616'.
	self assert: station name equals: 'Saejeol
(Sinsa)'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/19/2009 17:02'!
testStraightLineStations

	self assert: (line stations at: 1) name equals: 'Eungam'.
	self assert: (line stations at: 7) name equals: 'Saejeol
(Sinsa)'.
	self assert: (line stations at: 8) name equals: 'Jeungsan
(Myongji Univ.)'.
	self assert: (line stations at: 9) name equals: 'Digital Media City'.
	"..."
	self assert: (line stations at: 36) name equals: 'Taereung'.
	self assert: (line stations at: 37) name equals: 'Hwarangdae
(Seoul Women''s Univ.)'.
	self assert: (line stations at: 38) name equals: 'Bonghwasan'.! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 10/19/2009 16:44'!
testTimeSpanFromEungamToBonghwasan

	self assert: (self timeFrom: 'Eungam' to: 'Bonghwasan') equals: 58! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 15:13'!
testTimeSpanFromYeokchonToGusan

	self assert: (self timeFrom: 'Yeokchon' to: 'Gusan') equals: 9! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 15:14'!
testTimeSpanFromYeokchonToSaejeol

	self assert: (self timeFrom: 'Yeokchon' to: 'Saejeol
(Sinsa)') equals:  14! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 11:27'!
testYeokchon

	| station |
	station := line stations at: 2.
	self assert: station line equals: '6'.
	self assert: station id equals: '611'.
	self assert: station name equals: 'Yeokchon'! !

JhcLineRealDataTest subclass: #JhcLine7Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine7Test methodsFor: 'running' stamp: 'hjo 10/10/2009 09:23'!
setUp

	super setUp.
	line := JhcLine line7! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:20'!
testChildrensGrandPark

	| station |
	station := line stations at: 18.
	self assert: station line equals: '7'.
	self assert: station id equals: '726'.
	self assert: station name equals: 'Children''s Grand Park'! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:11'!
testDobongsan

	| station |
	station := line stations at: 2.
	self assert: station line equals: '7'.
	self assert: station id equals: '710'.
	self assert: station name equals: 'Dobongsan'! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:05'!
testFirstStationIsConnected

	self assert: line stations first graphVertex edges size = 1! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:35'!
testFromJunghwaToCheongdam

	self assert: (self timeFrom: 'Junghwa' to: 'Cheongdam') equals: 20! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:07'!
testIntermediateStationIsConnectedTwice

	line stations copyWithoutFirst copyWithoutLast
		do: [:each| self assert: each graphVertex edges size = 2]! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 09:30'!
testJangam

	| station |
	station := line stations at: 1.
	self assert: station line equals: '7'.
	self assert: station id equals: '709'.
	self assert: station name equals: 'Jangam'! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:04'!
testLastStationIsConnected

	self assert: line stations last graphVertex edges size = 1! !

!JhcLine7Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:42'!
testLineColor
	
	"RGB 84,100,13"
	self assert: line lineColor equals: (Color r:84/255 g:100/255 b:13/255)! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:36'!
testOnsu

	| station |
	station := line stations at: 42.
	self assert: station line equals: '7'.
	self assert: station id equals: '750'.
	self assert: station name equals: 'Onsu'! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:11'!
testSuraksan

	| station |
	station := line stations at: 3.
	self assert: station line equals: '7'.
	self assert: station id equals: '711'.
	self assert: station name equals: 'Suraksan'! !

JhcLineRealDataTest subclass: #JhcLine8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine8Test methodsFor: 'running' stamp: 'hjo 9/28/2009 13:16'!
setUp

	super setUp.
	line := JhcLine line8! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 9/28/2009 13:29'!
testAmsa

	| station |
	station := line stations at: 1.
	self assert: station line equals: '8'.
	self assert: station name equals: 'Amsa'.
	self assert: station id equals: '810'! !

!JhcLine8Test methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:44'!
testLineColor

	"RGB: 245,19,97"
	self assert: line lineColor equals: (Color r:245/255 g:19/255 b:97/255)! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 9/28/2009 15:05'!
testSongpa

	| station |
	station := line stations at: 7.
	self assert: station line equals: '8'.
	self assert: station name equals: 'Songpa'.
	self assert: station id equals: '816'! !

!JhcLine8Test methodsFor: 'etc' stamp: 'hjo 9/29/2009 11:10'!
testStationAndVertexHandshake

	| station |
	station := JhcStation new.
	self assert: (station graphVertex isKindOf: Vertex).
	self assert: (station graphVertex masterObject == station)! !

!JhcLine8Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:28'!
testTimeSpanFromAmsaToSongpa

	self assert: (self timeFrom: 'Amsa' to: 'Songpa') equals: 13! !

!JhcLine8Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:31'!
testTimeSpanFromBokjeongToSanseong

	self assert: (self timeFrom: 'Bokjeong' to: 'Sanseong') equals: 4! !

JhcLineRealDataTest subclass: #JhcLine9Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine9Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:47'!
setUp

	super setUp.
	line := JhcLine line9! !

!JhcLine9Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:46'!
testLineColor

	"RGB: 170,152,114"
	self assert: line lineColor equals: (Color r: 170/255 g:152/255 b:114/255)! !

!JhcLineRealDataTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 13:25'!
isAbstract

	^self name = #JhcLineRealDataTest! !

!JhcLineRealDataTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 09:56'!
timeFrom: from to: to
	| fromStation toStation |
	line stations do: [:each| each graphVertex clearMinimumCostPaths].
	fromStation := line stationAtName: from.
	toStation := line stationAtName: to.
	^fromStation timespanMinutesTo: toStation! !

TestCase subclass: #JhcLineTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:59'!
testLoadInput
	| input |
	input := '310	Daehwa	0'.
	line := JhcLine loadData: input for: '3'.
	self assert: (line line = '3').
	self assert: line stations size equals: 1.
	self assert: line stations first id equals: '310'.! !

!JhcLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:43'!
testReadStream
	| lines |
	
	lines := '3
abc	def	ghi' lines.
	self assert: (lines size = 2)
	! !

TestCase subclass: #JhcRoutingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 09:28'!
testBundangLine

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Seolleung' line: 'Bundang' id: 'K215').
	line add: (JhcStation newName: 'Hanti' line: 'Bundang' id: 'K216').
	line add: (JhcStation newName: 'Dogok' line: 'Bundang' id: 'K217').
	line add: (JhcStation newName: 'Guryong' line: 'Bundang' id: 'K218').
	line add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	line add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	line add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	line add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	line add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	line add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	line add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').
	line add: (JhcStation newName: 'Yatap' line: 'Bundang' id: 'K226').
	line add: (JhcStation newName: 'Imae' line: 'Bundang' id: 'K227').
	line add: (JhcStation newName: 'Seohyeon' line: 'Bundang' id: 'K228').
	line add: (JhcStation newName: 'Sunae' line: 'Bundang' id: 'K229').
	line add: (JhcStation newName: 'Jeongja' line: 'Bundang' id: 'K230').
	line add: (JhcStation newName: 'Migeum' line: 'Bundang' id: 'K231').
	line add: (JhcStation newName: 'Ori' line: 'Bundang' id: 'K232').
	line add: (JhcStation newName: 'Jukjeon' line: 'Bundang' id: 'K233').
	line add: (JhcStation newName: 'Bojeong' line: 'Bundang' id: 'K234').

	line doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	self assert: ((line at:1) timespanMinutesTo: (line at:15)) equals: 28! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 11:25'!
testLine8

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Amsa' line: '8' id: '810').
	line add: (JhcStation newName: 'Cheonho(Pungnaptoseong)' line: '8' id: '811').
	line add: (JhcStation newName: 'Gangdong-gu Office' line: '8' id: '812').
	line add: (JhcStation newName: 'Mongchontoseong(World Peace Gate)' line: '8' id: '813').
	line add: (JhcStation newName: 'Jamsil(Songpa-gu Office)' line: '8' id: '814').
	line add: (JhcStation newName: 'Seokchon' line: '8' id: '815').
	line add: (JhcStation newName: 'Songpa' line: '8' id: '816').
	line add: (JhcStation newName: 'Garak Market' line: '8' id: '817').
	line add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line add: (JhcStation newName: 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' line: '8' id: '822').
	line add: (JhcStation newName: 'Dandaegogeori' line: '8' id: '823').
	line add: (JhcStation newName: 'Sinheung' line: '8' id: '824').
	line add: (JhcStation newName: 'Sujin' line: '8' id: '825').
	line add: (JhcStation newName: 'Moran' line: '8' id: '826').

	line doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	self assert: ((line at:10) timespanMinutesTo: (line at:15)) equals: 10! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:27'!
testOneSegment

	| s t g |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	g := JhcSegment newTimespanMinutes: 2.

	s setStationAccess: t in: g.
	self assert: (s timespanMinutesTo: t) equals:2! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 17:04'!
testTransferFromBundangLineToLine8AtBokjeong

	| line8 bundangLine |
	line8 := OrderedCollection new.
	line8 add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line8 add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line8 add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line8 add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line8 add: (JhcStation newName: 'Namhansanseong' secondName: 'Seongnam Court & Public Prosecutor''s Office' line: '8' id: '822').

	line8 doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	bundangLine := OrderedCollection new.
	bundangLine add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	bundangLine add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	bundangLine add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	bundangLine add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	bundangLine add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	bundangLine add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	bundangLine add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').

	bundangLine doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	(line8 at: 3) graphVertex connect: (bundangLine at: 4) graphVertex cost: 7. "transfer link"
	
	self assert: (line8 first timespanMinutesTo: bundangLine last) equals: 17! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:45'!
testTwoSegment

	| s t u |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	u := JhcStation newName: 'ShinChon' line: 2 id: 240.

	self revisit: 'I think JhcSegment is not doing anything here. Simply CostEdge will be good enough.'.

	s graphVertex connect: t graphVertex cost: 2.
	t graphVertex connect: u graphVertex cost: 2.
	self assert: (s timespanMinutesTo: u) equals: 4! !

TestCase subclass: #JhcStationSelectTest
	instanceVariableNames: 'subway'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcStationSelectTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:21'!
setUp

	super setUp.
	subway := JhcSubway new! !

!JhcStationSelectTest methodsFor: 'filtering' stamp: 'hjo 10/19/2009 19:34'!
testFilterStations

	self assert: subway filteredStations size equals: subway stations size.
	
	subway filterBy: 'Sin'.
	self assert: subway filteredStations size < subway stations size! !

!JhcStationSelectTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:30'!
testStations

	"This test can be changed whenever the station data is gathered."
	self assert: subway stations size equals: 220! !

TestCase subclass: #JhcTransferStationTest
	instanceVariableNames: 'line2 seongsu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:04'!
setUp
	line2 := JhcLine line2.
	seongsu := line2 stationAtName: 'Seongsu'! !

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 13:06'!
testStationAtNameLine

	self deny: (line2 stationAtName: 'Seongsu' line: '2') == (line2 stationAtName: 'Seongsu' line: '2-seongsu-branch').
	self assert: (line2 stationAtName: 'Seongsu' line: '2') == (line2 stationAtName: 'Seongsu' line: '2')! !

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:07'!
testTransferStationHasIdenticalNameAndIdOfItsSubStations
	self assert:  seongsu name equals: 'Seongsu'.
	self assert:  seongsu id equals: '211'.! !

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 12:32'!
testTransferTimespan

	self 
		assert: 
			((line2 stationAtName: 'Seongsu' line: '2') timespanMinutesTo:
	(line2 stationAtName: 'Seongsu' line: '2-seongsu-branch'))
		equals: 11! !

TestCase subclass: #KeyedObjectAccessorTest
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:46'!
testSetArrayIndicesAs

	accessor := KeyedObjectAccessor new.
	accessor setArrayIndicesAs: #(id stationName timespan).
	accessor object: #('238' 'YongSan' '4').

	self assert: accessor id equals: '238'.
	self assert: accessor stationName equals: 'YongSan'.
	self assert: accessor timespan equals: '4'.
! !

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:33'!
testSetKeyAndAccessor

	accessor := KeyedObjectAccessor new.
	accessor setKey: 1 as: #id.
	accessor object: #('238').

	self assert: accessor id equals: '238'! !

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:40'!
testSetKeyAndAccessor2

	accessor := KeyedObjectAccessor new.
	accessor setKey: 1 as: #id.
	accessor setKey: 2 as: #stationName.
	accessor object: #('238' 'YongSan').

	self assert: accessor id equals: '238'.
	self assert: accessor stationName equals: 'YongSan'! !

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:42'!
testSetKeyAndAccessor3

	accessor := KeyedObjectAccessor new.
	accessor setKey: 1 as: #id.
	accessor setKey: 2 as: #stationName.
	accessor setKey: 3 as: #timespan.
	accessor object: #('238' 'YongSan' '4').

	self assert: accessor id equals: '238'.
	self assert: accessor stationName equals: 'YongSan'.
	self assert: accessor timespan equals: '4'.
! !

Object subclass: #IntegerStream
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'hjo 10/7/2009 21:00'!
current: aSmallInteger 

	current := aSmallInteger ! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
initialize
	current := 0! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
next
	|ret|
	ret := current.
	current := current + 1.
	^ret! !

Object subclass: #JhcLine
	instanceVariableNames: 'line idPrefix stations integerStream lineColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/7/2009 21:06'!
bundang

	| inst |
	inst := self new.
	inst line: 'Bundang'.
	inst idPrefix: 'K'.
	inst setIntegerForFirstStationId: 215.
	
	#('Seolleung' 'Hanti' 'Dogok' 'Guryong' 'Gaepo-dong' 'Daemosan' 'Suseo' 'Bokjeong' 'Kyungwon Univ.' 'Taepyeong' 'Moran' 'Yatap' 'Imae' 'Seohyeon' 'Sunae' 'Jeongja' 'Migeum' 'Ori' 'Jukjeon' 'Bojeong') do: [ :each | 
		inst addStationNamed: each ].
	inst connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 2 2 2 4 4 3 2 2 3 3 2 2 3 3 2 3 2).
	^inst! !

!JhcLine classSide methodsFor: 'instance helper' stamp: 'hjo 10/10/2009 15:17'!
connctStations: anArray withMinuteStream: aReadStream 

	self assert: [aReadStream size + 1 = anArray size ] description: 'number of edges are one less than number of vertices.'.
	anArray doCouple: [:a :b| a connect: b cost: aReadStream next ]! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/13/2009 13:57'!
line1

	| string instance |
	string := 
'133	Seoul Station	0
132	City Hall	2
131	Jonggak	3
130	Jongno 3(sam)-ga	1
129	Jongno 5(o)-ga	2
128	Dongdaemun	2
127	Dongmyo	2
126	Sinseol-dong	1
125	Jegi-dong	2
124	Cheongnyangni	2
'
.
	instance := 	self loadData: string for: '1'.
	instance lineColor: (Color r: 13/255 g: 54/255 b: 146/255).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/13/2009 14:27'!
line2

	| ring seongsu sinjeong instance |
	ring := self line2Ring.
	seongsu := self line2SeongsuBranch.
	sinjeong := self line2SinjeongBranch.
	instance := self new.
	instance line: '2'.

	instance stations addAll: ring stations.
	instance stations addAll: seongsu stations.
	instance stations addAll: sinjeong stations.

	(ring stationAtId: '234') connect: (sinjeong stationAtId: '234') cost: 13.
	(seongsu stationAtId: '211') connect: (ring stationAtId: '211') cost: 11.

	instance lineColor: (Color r: 51/255 g: 162/255 b: 61/255).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/19/2009 17:36'!
line2Ring

	| instance |
	instance := self new.
	instance line: '2'.
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 201.
	
	#('City Hall' 'Euljiro 1(il)-ga' 'Euljiro 3(sam)-ga' 'Euljiro 4(sa)-ga' 'Dongdaemun Stadium' 'Sindang' 'Sangwangsimni' 'Wangsimni' 'Hanyang Univ.' 'Ttukseom' 'Seongsu' 'Konkuk Univ.' 
	('Guui'   'Gwangjin-gu Office') ('Gangbyeon'   'Dongseoul Bus Terminal')  'Seongnae'  ('Jamsil' 'Songpa-gu Office') 'Sincheon'  'Sports Complex'   ('Samseong'  'World Trade Center Seoul')
	'Seolleung' 'Yeoksam' 'Gangnam' ('Seoul Nat''l Univ. of Education' 'Court &Public Prosecutor''s Office') 'Seocho' 'Bangbae' 'Sadang' 'Nakseongdae' ('Seoul Nat''l Univ.'  'Gwanak-gu Office')
	'Bongcheon' 'Sillim' 'Sindaebang' 'Guro Digital Complex' ('Daerim' 'Guro-gu Office') 'Sindorim' 'Mullae' 'Yeongdeungpo-gu Office' 'Dangsan' 'Hapjeong' 'Hongik Univ.' 'Sinchon' 
	'Ewha Womans Univ.' 'Ahyeon' ('Chungjeongno' 'Kyonggi Univ.'))
		do: [:each| each isString ifTrue:  [instance addStationNamed: each] ifFalse: [ instance addStationNamed: each first secondName: each second ] ].

	instance connectStationsInRange: (1 to: 43), (Array with: 1) withEdgesWithTimeSpanMinutes:  #(2 2 1 2 2 2 1 2 3 1 2 3 2 3 3 2 2 2 2 2 2 2 1 3 3 2 2 2 2 2 2 2 3 3 1 2 4 2 3 2 1 2 2).

	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/19/2009 17:58'!
line2SeongsuBranch

	| instance accessor |
	instance := self new.
	instance line: '2-seongsu-branch'.
	
	accessor := KeyedObjectAccessor new.
	accessor setArrayIndicesAs: #(stationName secondName id).
	#(
		('Seongsu' nil '211')
		('Yongdap' nil '211-1')
		('Sindap' nil '211-2')
		('Yongdu' 'Dongdaemun-gu Office' '211-3')
		('Sinseol-dong' nil '211-4')
	)
		do: [:data| 
			accessor object: data.
			instance addStationNamed: accessor stationName secondName: accessor secondName id: accessor id.
			].
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(3 2 2 2).
	^instance
	! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'jhan 10/13/2009 10:01'!
line2SinjeongBranch

	| instance |
	instance := self new.
	instance line: '2-sinjeong-branch'.
	
	#(
		('Sindorim' '234')
		('Dorimcheon' '234-1')
		('Yangcheon-gu Office' '234-2')
		('Sinjeongnegeori' '234-3')
		('Kkachisan' '234-4')
	)
		do: [:data| 
			instance addStationNamed: data first id: data second ].
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 3 4 3).
	^instance
	! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/19/2009 19:05'!
line3
	| input |
	
	input := '310	Daehwa	0
311	Juyeop	2
312	Jeongbalsan	3
313	Madu	2
314	Baekseok	2
315	Daegok	4
316	Hawjeong	3
317	Wondang	3
318	Samsong	5
319	Jichuk	3
320	Gupabal	4
321	Yeonshinnae	2
322	Bulgwang	2
323	Nokbeon	2
324	Hongje	3
325	Muakjae	2
326	Dongnimmun	2
327	Gyeongbokgung	2
328	Anguk	2
329	Jongno 3(sam)-ga	2
330	Euljiro 3(sam)-ga	2
331	Chungmuro	1
332	Dongguk Univ.	3
333	Yaksu	1
334	Geumho	1
335	Oksu	2
336	Apgujeong	2
337	Sinsa	3
338	Jamwon	2
339	Express Bus Terminal	2
340	Seoul Nat''l Univ. of Education	2
341	Nambu Bus Terminal	2
342	Yangjae	3
343	Maebong	2
344	Dogok	2
345	Daechi	2
346	Hangnyeoul	1
347	Daecheng	2
348	Irwon	2
349	Suseo	3'.
		self revisit: 'need to apply secondName to all stations in line 3.'.
		^(self loadData: input for: '3') lineColor: (Color r:254/255 g:91/255 b:16/255)! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:36'!
line4
	
	^self new lineColor: (Color r:50/255 g:161/255 b:200/255 )! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:38'!
line5
	
	^self new lineColor: (Color r: 139/255 g: 80/255 b: 164/255 )! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/19/2009 16:44'!
line6
	
	| instance |
	instance := self new.
	instance line: '6'.
	instance lineColor: (Color r:197/255 g:92/255 b:29/255).
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 610.
	#('Eungam' 'Yeokchon' 'Bulgwang' 'Dokbawi' 'Yeonsinnae' 'Gusan' 'Saejeol
(Sinsa)' 'Jeungsan
(Myongji Univ.)'	 'Digital Media City' 'World Cup Stadium
(Seongsan)' 'Mapo-gu Office' 'Mangwon' 'Hapjeong' 'Sangsu' 'Gwangheungchang (Seogang)' 'Daeheung
(Sogang Univ.)' 'Gongdeok' 'Hyochang Park
(Yongsan-gu Office)' 'Samgakji' 'Noksapyeong' 'Itaewon' 'Hangangjin' 'Beotigogae' 'Yaksu' 'Cheonggu' 'Sindang' 'Dongmyo' 'Changsin' 'Bomun' 'Anam
(Korea Univ. Hospital)' 'Korea Univ.
(Jongam)' 'Wolgok
(Dongduk Women''s Univ.)'	 'Sangwolgok
(KIST)' 'Dolgoji' 'Seokgye' 'Taereung' 'Hwarangdae
(Seoul Women''s Univ.)' 'Bonghwasan') do: [ :each | 
		instance addStationNamed: each ].
	instance connectStationsInRange: (Array with: 1), (7 to: 38) withEdgesWithTimeSpanMinutes:  #(2 2 1 2 2 2 2 1 2 2 2 2 2 2 1 2 2 2 2 1 2 2 1 2 2 2 2 1 2 2 2 2).
	instance connectStationsWithDirectionInRange: (1 to: 6) , (1 to: 1) withEdgesWithTimeSpanMinutes: #(2 2 2 3 2 3).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/13/2009 14:43'!
line7

	| instance |
	instance := self new.
	instance line: '7'.
	instance lineColor: (Color r:84/255g:100/255b:13/255).
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 709. "?"

	#(	'Jangam' 'Dobongsan' 'Suraksan' 'Madeul' 'Nowon' 'Junggye'
	'Hagye' 'Gongneung' 'Taereung' 'Meokgol' 'Junghwa' 'Sangbong'
	'Myeonmok' 'Sagajeong' 'Yongmasan' 'Junggok' 'Gunja' 'Children''s Grand Park'
	'Konkuk Univ.' 'Ttukseom Resort' 'Cheongdam' 'Gangnam-gu Office' 'Hak-dong'
	'Nonhyeon' 'Banpo' 'Express Bus Terminal' 'Naebang' 'Isu' 'Namseong'
	'Soongsil Univ.' 'Sangdo' 'Jangseungbaegi' 'Sindaebangsamgeori' 'Boramae'
	'Sinpung' 'Daerim' 'Namguro' 'Gasan Digital Complex' 'Cheolsan' 'Gwangmyeongsageori'
	'Cheonwang' 'Onsu'
	)
		do: [:stationName| 
			instance addStationNamed: stationName ].
	instance connectStationsWithEdgesWithTimeSpanMinutes:  #(3 2 2 2 2 2 1 2 2 2 2 2 1 2 2 2 2 2 3 2 1 2 2 2 3 2 2 3 1 2 3 1 2 3 2 1 3 2 3 3 2).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/13/2009 14:45'!
line8

	| instance |
	instance := self new.
	instance line: '8'.
	instance lineColor: (Color r:245/255g:19/255b:97/255).
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 810.
	
	#('Amsa' 'Cheonho(Pungnaptoseong)' 'Gangdong-gu Office' 'Mongchontoseong(World Peace Gate)' 'Jamsil(Songpa-gu Office)' 'Seokchon' 'Songpa' 'Garak Market' 'Munjeong' 'Jangji' 'Bokjeong' 'Sanseong' 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' 'Dandaegogeori' 'Sinheung' 'Sujin' 'Moran') do: [ :each | 
		instance addStationNamed: each ].
	
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 3 2 2 2 2 2 2 2 4 3 2 2 2 2).
	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:48'!
line9

	^self new lineColor: (Color r:170/255 g:152/255 b:114/255)! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/12/2009 17:52'!
loadData: input for: lineId
	| instance literalArrays prevStation nextStation accessor |
	
	instance := self new.
	instance line: lineId.
	
	literalArrays := input lines collect: [ :each |
			self parseInputLine: each
		].

	accessor := KeyedObjectAccessor new.
	accessor setArrayIndicesAs: #(id stationName timespanToArrive).
	
	"add first station"
	accessor object: literalArrays first.
	instance addStationNamed: accessor stationName id: accessor id.
								
	literalArrays doCouple: [:prevRow :nextRow|
		accessor object: prevRow.
		prevStation := instance stationAtName: accessor stationName.
		accessor object: nextRow.
		nextStation := instance addStationNamed: accessor stationName id: accessor id.
		prevStation connect: nextStation cost: accessor timespanToArrive asNumber.
		].
	
	"if the line is circular one, then connect first and last stations"
	accessor object: literalArrays first.
	(accessor timespanToArrive = '0') ifFalse: [
		instance stations first connect: instance stations last cost: accessor timespanToArrive asNumber].
	^instance! !

!JhcLine classSide methodsFor: 'instance helper' stamp: 'jhan 10/12/2009 00:24'!
parseInputLine: line
	^line subStrings: Character tab asString! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:50'!
addStationNamed: aByteString 
	^self addStationNamed: aByteString idNumber: self nextIdNumber! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/11/2009 22:06'!
addStationNamed: aByteString id: niceIdString

	^stations add: (JhcStation newName: aByteString line: line id: niceIdString)! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:49'!
addStationNamed: aByteString idNumber: aSmallInteger 

	^stations add: (JhcStation newName: aByteString line: line id: idPrefix , aSmallInteger printString)
! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/19/2009 17:38'!
addStationNamed: aByteString secondName: aByteString2 

	| newStation |
	newStation := self addStationNamed: aByteString.
	newStation secondName: aByteString2.
	^newStation! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/19/2009 19:00'!
addStationNamed: aByteString secondName: nilOrString id: aByteString3 

	| newStation |
	newStation := self addStationNamed: aByteString  id: aByteString3.
	newStation secondName: nilOrString.
	^newStation! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/10/2009 15:13'!
connectStationsInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	self class connctStations: (indicesOfStation collect: [:each| stations at: each]) withMinuteStream: minutes readStream! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:12'!
connectStationsWithDirectionInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	| minutesStream |
	minutesStream := minutes readStream.
	(indicesOfStation collect: [:each| stations at: each]) doCouple: [:a :b| a connectTo: b  cost: minutesStream next ].! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/10/2009 15:15'!
connectStationsWithEdgesTimeSpan2Minutes

	self class connctStations: stations withMinuteStream: (stations size copiesOf: 2) readStream! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/10/2009 15:40'!
connectStationsWithEdgesWithTimeSpanMinutes: anArray 

	self class connctStations: stations withMinuteStream: anArray readStream! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
idPrefix: aByteString 

	idPrefix := aByteString ! !

!JhcLine methodsFor: 'initialize-release' stamp: 'hjo 9/27/2009 22:00'!
initialize

	super initialize.
	stations := OrderedCollection new! !

!JhcLine methodsFor: 'accessing' stamp: 'jhan 10/2/2009 00:33'!
integerStream
	integerStream isNil ifTrue: [ integerStream := IntegerStream new ].
	^integerStream! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:11'!
line
	^line! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
line: aByteString 

	line :=  aByteString ! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/13/2009 13:49'!
lineColor

	^lineColor! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/13/2009 13:55'!
lineColor: aColor 

	lineColor := aColor! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/2/2009 00:48'!
neighbors
	self shouldBeImplemented! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:32'!
nextIdNumber
	^self integerStream next! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/7/2009 21:02'!
setIntegerForFirstStationId: aSmallInteger 

	self integerStream current: aSmallInteger! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/13/2009 10:26'!
stationAtId: aByteString 

	| subStations |
	subStations := self stations select: [:each| each id = aByteString ].
	(subStations size = 1) ifTrue: [ ^subStations first ]
								ifFalse: [ ^JhcTransferStation with: subStations ]! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/12/2009 23:50'!
stationAtName: aByteString 

	| subStations |
	subStations := self stations select: [:each| each name = aByteString ].
	(subStations size = 1) ifTrue: [ ^subStations first ]
								ifFalse: [ ^JhcTransferStation with: subStations ]! !

!JhcLine methodsFor: 'query' stamp: 'hjo 10/13/2009 12:33'!
stationAtName: aByteString line: aByteString2 

	| arrayOfOneStation |
	arrayOfOneStation := (self  stations select: [:each| each name = aByteString]) select: [:each| each line = aByteString2].
	self assert: [arrayOfOneStation size = 1] description: 'There is only one station that of name and line id combination.'.
	^arrayOfOneStation anyOne! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:27'!
stations

	^stations! !

Object subclass: #JhcSegment
	instanceVariableNames: 'timespanMinutes graphEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSegment classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:15'!
newTimespanMinutes: aNumber

	^self new
		timespanMinutes: aNumber 

	! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 18:52'!
graphEdge

	^graphEdge! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 10:02'!
initialize

	super initialize.
	graphEdge := CostEdge new.
	graphEdge masterObject: self! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:22'!
timespanMinutes

	^timespanMinutes! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:36'!
timespanMinutes: aNumber

	self revisit: 'duplicate information!!'.
	timespanMinutes := aNumber.
	graphEdge cost: aNumber! !

Object subclass: #JhcStation
	instanceVariableNames: 'name id line graphVertex secondName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:03'!
defaultCost
	^2! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 09:34'!
newName: aByteString id: aByteString2 

	self revisit: 'DELETE ME!!'! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 18:05'!
newName: aByteString line: aSmallInteger id: aSmallInteger3 

	^self new
		name: aByteString;
		line: aSmallInteger;
		id: aSmallInteger3! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 17:06'!
newName: aByteString secondName: aByteString2 line: aByteString3 id: aByteString4 

	^self new
		name: aByteString;
		line: aByteString3;
		id: aByteString4;
		secondName: aByteString2! !

!JhcStation methodsFor: 'testing' stamp: 'jhan 10/2/2009 01:06'!
canDirectlyGo: aJhcStation
	^graphVertex neighboringVertices anySatisfy: [:each| each masterObject = aJhcStation]! !

!JhcStation methodsFor: 'testing' stamp: 'hjo 9/26/2009 19:27'!
canGo: aJhcStation in: aJhcSegment 

	^graphVertex leavingEdges anySatisfy: [:each| each masterObject == aJhcSegment ]
! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:03'!
connect: aJhcStation 
	self connect: aJhcStation cost: self class defaultCost! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:00'!
connect: other cost: c 
	self graphVertex connect: other graphVertex cost: c! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:14'!
connectTo: otherStation cost: aSmallInteger 
	self graphVertex connectTo: otherStation graphVertex cost: aSmallInteger! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 10/8/2009 16:16'!
detailPrintStringForVertex

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/26/2009 19:30'!
graphVertex

	^graphVertex! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:31'!
id

	^id! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
id: aSmallInteger 

	id := aSmallInteger! !

!JhcStation methodsFor: 'initialize-release' stamp: 'hjo 9/29/2009 11:11'!
initialize

	super initialize.
	graphVertex := CostVertex new.
	graphVertex masterObject: self! !

!JhcStation methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:41'!
isPositiveToFilterQuery: filterQuery

	"Not sensitive to case."
	| lowercaseQuery |
	filterQuery isNil ifTrue: [ ^true].
	lowercaseQuery := filterQuery asLowercase.
	^(filterQuery name asLowercase indexOfSubCollection: lowercaseQuery) > 0! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/18/2009 13:47'!
line

	^line! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
line: aSmallInteger 

	line := aSmallInteger! !

!JhcStation methodsFor: 'accessing' stamp: 'jhan 10/12/2009 23:23'!
lines

	^{line}! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:01'!
name

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
name: aByteString 
	name := aByteString! !

!JhcStation methodsFor: 'querying' stamp: 'jhan 10/2/2009 00:54'!
neighbors
	^self graphVertex neighbors collect: [ :neighbor | neighbor masterObject ]! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 9/28/2009 12:38'!
printVertexDetailOn: aStream

	aStream print: name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/19/2009 16:56'!
secondName

	"Most stations does not have a second name. But some stations have second name scripted inside of parenthesis.
	e.g.)   Jamsil (Songpa-gu Office) 
	Songpa-gu Office is the second name for Jamsil station."
	^secondName! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/19/2009 16:57'!
secondName: aString

	"Most stations does not have a second name. But some stations have second name scripted inside of parenthesis.
	e.g.)   Jamsil (Songpa-gu Office) 
	Songpa-gu Office is the second name for Jamsil station."
	secondName := aString! !

!JhcStation methodsFor: 'collecting' stamp: 'hjo 9/26/2009 20:18'!
setStationAccess: aJhcStation in: aJhcSegment 

	aJhcSegment graphEdge connect: self graphVertex and: aJhcStation graphVertex.
	self assert: [self graphVertex hasEdge: aJhcSegment graphEdge] description: 'Hand shake?'.
	self assert: [aJhcStation graphVertex hasEdge: aJhcSegment graphEdge] description: 'Hand shake?'! !

!JhcStation methodsFor: 'querying' stamp: 'jhan 10/13/2009 09:53'!
timespanMinutesFromSingleStation: aJhcStation 
	
	self revisit: 'CostVertices in the Graph must be initialized some how.'.
	self graphVertex computeMinimumCostGraphPathsFrom: aJhcStation graphVertex.
	^self graphVertex minimumCost! !

!JhcStation methodsFor: 'querying' stamp: 'jhan 10/13/2009 00:33'!
timespanMinutesTo: aJhcStation 

	^aJhcStation timespanMinutesFromSingleStation: self.! !

Object subclass: #JhcSubway
	instanceVariableNames: 'lines filteredStations filterQuery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:26'!
buildAllLines

	^ #(bundang line1 line2 line3 line6 line7 line8)
			collect: [:instantiationMethod| JhcLine perform: instantiationMethod ]! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:38'!
filterBy: aByteString 

	filterQuery = aByteString
		ifFalse: [ 
			filterQuery := aByteString.
			filteredStations := nil
			]! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:36'!
filteredStations
	
	filteredStations isNil ifTrue: [ filteredStations := self stations collect: [:each| each isPositiveToFilterQuery: filterQuery ] ].
	^filteredStations! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:24'!
initialize

	super initialize.
	lines := self buildAllLines! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:28'!
stations

	^Array streamContents: [:stream| 
		lines do: [:each|  stream nextPutAll: each stations ]
		]! !

Object subclass: #JhcTransferStation
	instanceVariableNames: 'subStations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcTransferStation commentStamp: 'jhan 10/13/2009 10:25' prior: 0!
I am a station where people can transfer between lines. I have several sub stations. Each sub station represents a station dedicated a single line. For example, line2 and line2-seongsu-branch has its own 'Seongsu' station. Two seongsu station forms a Transfer station of 'Seongsu'. I forwards the name and id to the first of my sub stations.
I don't have a dedicated graphVertex because I have several of them. So I sometimes behave like a composite node in Composite pattern. If you find a station using name or id, JhcLine creates me in case there're two ore more stations have the same name.!

!JhcTransferStation classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:34'!
with: subStations 
	^self new
		subStations: subStations
	! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:07'!
id
	^subStations first id.! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:53'!
lines
	^ subStations collect: [:eachSubStation| eachSubStation line]! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:06'!
name
	^subStations first name! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:36'!
subStations
	(subStations isNil) ifTrue: [subStations := OrderedCollection new].
	^subStations! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:35'!
subStations: anOrderedCollection 
	self subStations addAll: anOrderedCollection! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 00:36'!
timespanMinutesFromSingleStation: srcStation
	| timespans |
	timespans := subStations collect: 
		[:eachSubStation| eachSubStation timespanMinutesFromSingleStation: srcStation].
	^timespans min! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 00:19'!
timespanMinutesTo: destStation
	| timespans |
	timespans := subStations collect: 
		[:eachSubStation| eachSubStation timespanMinutesTo: destStation].
	^timespans min! !

Object subclass: #KeyedObjectAccessor
	instanceVariableNames: 'keyMap keyedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!KeyedObjectAccessor methodsFor: 'error handling' stamp: 'hjo 10/12/2009 17:41'!
doesNotUnderstand: aMessage 

	"WARNING: There is potential bug. If the developer setKey:as: which I can understand, I will not work properly."
	^keyedObject perform: #at: with: (keyMap at: aMessage selector)! !

!KeyedObjectAccessor methodsFor: 'initialize-release' stamp: 'hjo 10/12/2009 17:38'!
initialize

	super initialize.
	keyMap := Dictionary new
	! !

!KeyedObjectAccessor methodsFor: 'accessing' stamp: 'hjo 10/12/2009 17:36'!
object: anObject

	keyedObject := anObject! !

!KeyedObjectAccessor methodsFor: 'accessing' stamp: 'hjo 10/12/2009 17:46'!
setArrayIndicesAs: arrayOfSelectors

	arrayOfSelectors keysAndValuesDo: [:index :selector| 
		self setKey: index as: selector
		]! !

!KeyedObjectAccessor methodsFor: 'accessing' stamp: 'hjo 10/12/2009 17:39'!
setKey: key as: accessorSelector

	keyMap at: accessorSelector put: key

	! !
